Draft PointArray: Difference between revisions

From FreeCAD Documentation
(Marked this version for translation)
(Updated Scripting)
Line 95: Line 95:


<!--T:11-->
<!--T:11-->
To create a point array use the {{incode|make_point_array}} method ({{Version|0.19}}) of the Draft module. This method replaces the deprecated {{incode|makePointArray}} method.
The PointArray tool can be used in [[macros|macros]] and from the [[Python|Python]] console by using the following function:

<!--T:29-->
Older call:

</translate>
{{Code|code=
point_array = makePointArray(base_object, point_object)
}}
<translate>

<!--T:30-->
New call:


</translate>
</translate>
Line 116: Line 104:


<!--T:12-->
<!--T:12-->
* Creates a {{incode|"PointArray"}} object from the {{incode|base_object}}, by placing the copies in the points contained within {{incode|point_object}}.
* {{incode|base_object}} is the object to be arrayed. It can also be the {{incode|Label}} (string) of an object in the current document.
** {{incode|point_object}} should have one of {{incode|Geometry}}, {{incode|Links}}, or {{incode|Components}} attributes containing points.
* {{incode|point_object}} is the object containing the points. It can also be the {{incode|Label}} (string) of an object in the current document. It should have a {{incode|Geometry}}, {{incode|Links}}, or {{incode|Components}} property containing points.
** Instead of a reference to an object, {{incode|base_object}} and {{incode|point_object}} can also be {{incode|Labels}} (strings) of objects existing in the current document.
* {{incode|extra}} can be a full {{incode|App.Placement}}, or just an {{incode|App.Vector}} or an {{incode|App.Rotation}}.
** {{incode|extra}} can be a full {{incode|App.Placement}}, or just an {{incode|App.Vector}} or {{incode|App.Rotation}}.


<!--T:13-->
<!--T:13-->

Revision as of 10:36, 24 May 2021

This documentation is a work in progress. Please don't mark it as translatable since it will change in the next hours and days.

Draft PointArray

Menu location
Modification → Array tools → Point array
Workbenches
Draft, Arch
Default shortcut
None
Introduced in version
0.18
See also
Draft OrthoArray, Draft PolarArray, Draft CircularArray, Draft PathArray, Draft PathLinkArray, Draft PointLinkArray, Draft Clone

Description

The Draft PointArray tool places copies of a selected shape along various selected points.

The PointArray tool can be used on any object that has a Part TopoShape, meaning 2D shapes created with the Draft Workbench, but also 3D solids created with other workbenches, for example, Part, PartDesign, or Arch.

Object arranged at specific points

Usage

  1. Select the object that you wish to distribute.
  2. Select a point compound.
  3. Press the PointArray button.

Each element in the array is an exact clone of the original object, but the entire array is considered a single unit in terms of properties and appearance.

Point compound

The point compound object can be created in different ways.

In essence, the object to be used as the compound must have one of three properties, DataComponents, DataLinks, or DataGeometry, and inside that compound, there must be at least one point with DataX, DataY, and DataZ properties.

Note: in the case of Draft Point and Part Point the array will try to position the copies using the DataPlacement of the point. In the case of a Sketcher Point, the position will be taken from its internal X, Y, and Z attributes.

Note 2: for Draft Point its DataPlacement always follows the values of DataX, DataY, DataZ, so modifying these values is enough to produce the desired displacement. However, for Part Point, the net displacement is given by the sum of DataPlacement with the vector with components DataX, DataY, and DataZ.

Options

There are no options for this tool. Either it works with the selected objects or not.

Properties

A PointArray is derived from a Part Feature (Part::Feature class), therefore it shares all the latter's properties. In addition to the properties described in Part Feature, the PointArray has the following properties in the property editor.

Objects

  • DataBase (Link): the object to duplicate; it must have a Part TopoShape.
  • DataCount (Integer): (read-only) specifies the number of copies in the array. This property is read-only because the number of copies is determined by the number of points inside of DataPoint Object.
  • DataExtra Placement (Placement): specifies an additional placement, translation and rotation, that will be applied to each copy in the array. Each copy normally appears with the same rotation as the DataBase object; with this property it is possible to provide additional rotation, or counter the original rotation, and make small adjustments to the position of the copies. introduced in version 0.19
  • DataPoint Object (Link): specifies a compound object with points that indicate where the copies of the DataBase object will appear. The compound object needs to have one of DataLinks, DataComponents, or DataGeometry properties, and contain at least one element with DataX, DataY, and DataZ attributes.

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To create a point array use the make_point_array method (introduced in version 0.19) of the Draft module. This method replaces the deprecated makePointArray method.

point_array = make_point_array(base_object, point_object, extra=None):
  • base_object is the object to be arrayed. It can also be the Label (string) of an object in the current document.
  • point_object is the object containing the points. It can also be the Label (string) of an object in the current document. It should have a Geometry, Links, or Components property containing points.
  • extra can be a full App.Placement, or just an App.Vector or an App.Rotation.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

polygon = Draft.make_polygon(3, radius=500.0)

p1 = Draft.make_point(App.Vector(1500, 0, 0))
p2 = Draft.make_point(App.Vector(2500, 0, 0))
p3 = Draft.make_point(App.Vector(2000, 1000, 0))

compound = doc.addObject("Part::Compound", "Compound")
compound.Links = [p1, p2, p3]

point_array = Draft.make_point_array(polygon, compound)
doc.recompute()